=== texmf-dist/doc/dvipdfm/Makefile ===
clean:
	rm -f *.dvi *.log sample.pdf *~
