=== debian/changelog ===
texlive-base (2025.20250927-4) unstable; urgency=medium

  * Remove broken link /usr/share/texmf/web2c/texmfcnf.lua.

 -- Hilmar Preuße <hille42@debian.org>  Mon, 27 Oct 2025 14:31:24 +0100

texlive-base (2025.20250927-3) unstable; urgency=medium

  * The depend introduced in last upload must be versioned.
    (Closes: #1116661)

 -- Hilmar Preuße <hille42@debian.org>  Tue, 30 Sep 2025 00:31:50 +0200

texlive-base (2025.20250927-2) unstable; urgency=medium

  * Some files to build luatex based format files are in texlive-luatex.
    Add this package to Depends in texlive-latex-base for now
    (Closes: #1116506).

 -- Hilmar Preuße <hille42@debian.org>  Mon, 29 Sep 2025 07:55:56 +0200

texlive-base (2025.20250927-1) unstable; urgency=medium

  * New upstream snapshot, refresh / disable patches.
  * Remove link to jquery.js and Dep on libjs-jquery (Closes: #1114545).

 -- Hilmar Preuße <hille42@debian.org>  Sat, 27 Sep 2025 22:58:17 +0200
